"use strict";

var _findAllFiles = _interopRequireDefault(require("../findAllFiles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

it('uses relative paths', function () {
  return (0, _findAllFiles.default)(process.cwd(), []).then(function (files) {
    expect(files[0].path).toMatch(/\.\//);
  });
});
it('has mtimes', function () {
  return (0, _findAllFiles.default)(process.cwd(), []).then(function (files) {
    expect(files[0].mtime).toBeGreaterThan(0);
  });
});
it('excludes files', function () {
  return (0, _findAllFiles.default)(process.cwd(), ['./**/__test__/**']).then(function (files) {
    expect(files.length).toBeGreaterThan(0);
    var testFiles = files.map(function (_ref) {
      var path = _ref.path;
      return path;
    }).filter(function (path) {
      return /__test__/.test(path);
    });
    expect(testFiles).toEqual([]);
    var libFiles = files.map(function (_ref2) {
      var path = _ref2.path;
      return path;
    }).filter(function (path) {
      return /lib/.test(path);
    });
    expect(libFiles.length).toBeGreaterThan(0);
  });
});
it('excludes node_modules', function () {
  return (0, _findAllFiles.default)(process.cwd(), []).then(function (files) {
    var nodeModules = files.map(function (_ref3) {
      var path = _ref3.path;
      return path;
    }).filter(function (path) {
      return /node_modules/.test(path);
    });
    expect(nodeModules).toEqual([]);
  });
});