"use strict";

var _lastUpdate = _interopRequireDefault(require("../lastUpdate"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

it('works for existing files', function () {
  return (0, _lastUpdate.default)('./lib/__tests__/lastUpdate-test.js', process.cwd()).then(function (result) {
    expect(result.path).toEqual('./lib/__tests__/lastUpdate-test.js');
    expect(result.mtime).toBeGreaterThan(0);
  });
});
it('rejects for non-existing files', function () {
  return (0, _lastUpdate.default)('./bogus').then(function () {
    throw new Error('err');
  }).catch(function (e) {
    expect(e).toBeDefined();
  });
});
it('does not reject when using failSafe', function () {
  return _lastUpdate.default.failSafe('./bogus', process.cwd()).then(function (result) {
    expect(result.path).toEqual('./bogus');
    expect(result.mtime).toBe(0);
  });
});