"use strict";

var _normalizePath = _interopRequireDefault(require("../normalizePath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('normalizePath', function () {
  it('returns ./ if there is no path', function () {
    expect((0, _normalizePath.default)('', '/path/to/project')).toEqual('./');
  });
  it('relativizes paths to the working directory', function () {
    expect((0, _normalizePath.default)('/path/to/project/foo/bar.js', '/path/to/project')).toEqual('./foo/bar.js');
  });
  it('leaves . alone', function () {
    expect((0, _normalizePath.default)('.', '/path/to/project')).toEqual('.');
  });
  it('leaves paths starting with ./ alone', function () {
    expect((0, _normalizePath.default)('./hi/there.js', '/path/to/project')).toEqual('./hi/there.js');
  });
  it('relativizes paths not starting with a /', function () {
    expect((0, _normalizePath.default)('foo/bar.js', '/path/to/project')).toEqual('./foo/bar.js');
  });
  it('relativizes paths starting with a / to the working directory', function () {
    expect((0, _normalizePath.default)('/foo/bar.js', '/path/to/project')).toEqual('./foo/bar.js');
  });
  it('relativizes dot-files', function () {
    expect((0, _normalizePath.default)('.importjs.js', '/path/to/project')).toEqual('./.importjs.js');
  });
});