"use strict";

var _path = _interopRequireDefault(require("path"));

var _parse = _interopRequireDefault(require("../parse"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var local = function local(subPath) {
  return _path.default.resolve(__dirname, subPath);
};

it('knows about object rest spread', function () {
  expect(function () {
    return (0, _parse.default)("\n    const { a, b, ...c } = foo;\n    ", local('foo,js'));
  }).not.toThrowError();
});
it('knows about decorators', function () {
  expect(function () {
    return (0, _parse.default)("\n    @Awesome\n    class Foo {};\n    ", local('foo,js'));
  }).not.toThrowError();
});
it('knows about class properties', function () {
  expect(function () {
    return (0, _parse.default)("\n    class Foo {\n      foo = 'bar';\n    }\n    ", local('foo,js'));
  }).not.toThrowError();
});
it('knows about dynamic imports', function () {
  expect(function () {
    return (0, _parse.default)("\n    import('./foo').then(module => module());\n    ", local('foo,js'));
  }).not.toThrowError();
});