"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = findAllFiles;

var _glob = _interopRequireDefault(require("glob"));

var _lastUpdate = _interopRequireDefault(require("./lastUpdate"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findAllFiles(workingDirectory, excludes) {
  return new Promise(function (resolve, reject) {
    (0, _glob.default)('./**/*.{j,t}s*', {
      ignore: ['./node_modules/**'].concat(excludes),
      cwd: workingDirectory
    }, function (err, files) {
      if (err) {
        reject(err);
        return;
      }

      Promise.all(files.map(function (pathToFile) {
        return (0, _lastUpdate.default)(pathToFile, workingDirectory);
      })).then(resolve);
    });
  });
}

module.exports = exports["default"];