"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = findProjectRoot;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isWinDriveRoot = /^[A-Z]:\\$/;

function findRecursive(directory) {
  if (directory === '/' || isWinDriveRoot.test(directory)) {
    throw new Error('No project root found, looking for a directory with a package.json file.');
  }

  var pathToPackageJson = _path.default.join(directory, 'package.json');

  if (_fs.default.existsSync(pathToPackageJson)) {
    return directory;
  }

  return findRecursive(_path.default.dirname(directory));
}

function makeAbsolute(pathToFile) {
  if (_path.default.isAbsolute(pathToFile)) {
    return pathToFile;
  }

  return _path.default.join(process.cwd(), pathToFile);
}

function findProjectRoot(pathToFile) {
  return findRecursive(_path.default.dirname(makeAbsolute(pathToFile)));
}

module.exports = exports["default"];